var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Fragment as _Fragment, jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useEffect } from 'react';
import BarChart from '../charts/BarChart.js';
import LineChart from '../charts/LineChart.js';
import StackChart from '../charts/StackChart.js';
import PieChart from '../charts/PieChart.js';
import Table from '../charts/Table.js';
import ChartTitle from './ChartTitle.js';
var ChartContainer = function (_a) {
    var setup = _a.setup, index = _a.index, configuration = _a.configuration;
    var _b = React.useState('loading'), status = _b[0], setStatus = _b[1];
    var _c = React.useState([]), chartData = _c[0], setChartData = _c[1];
    var _d = React.useState(null), subChartData = _d[0], setSubChartData = _d[1];
    var getChartDataAsync = function (arg) { return __awaiter(void 0, void 0, void 0, function () {
        var result, _a;
        var _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _c.trys.push([0, 2, , 3]);
                    setStatus('loading');
                    return [4, configuration.fnGetChartDataAsync(arg)];
                case 1:
                    result = _c.sent();
                    if (!(result === null || result === void 0 ? void 0 : result.data) || result.data.length === 0) {
                        setStatus('empty');
                        setChartData([]);
                        setSubChartData(null);
                    }
                    else {
                        setStatus('loaded');
                        setChartData(result.data.filter(function (item) { return item !== null && item !== undefined; }));
                        setSubChartData(((_b = result.sub) === null || _b === void 0 ? void 0 : _b.filter(function (item) { return item !== null && item !== undefined; })) ||
                            null);
                    }
                    return [3, 3];
                case 2:
                    _a = _c.sent();
                    setStatus('error');
                    setChartData([]);
                    setSubChartData(null);
                    return [3, 3];
                case 3: return [2];
            }
        });
    }); };
    useEffect(function () {
        getChartDataAsync({ id: setup.id });
    }, [setup.id, configuration.fnGetChartDataAsync]);
    var renderChartComponent = function () {
        if (status !== 'loaded') {
            return _jsx(_Fragment, {});
        }
        switch (setup.type) {
            case 'vertical-bar-chart':
            case 'horizontal-bar-chart':
                return _jsx(BarChart, { setup: setup, chartData: chartData }, index);
            case 'line-chart':
            case 'step-line-chart':
                return _jsx(LineChart, { setup: setup, chartData: chartData }, index);
            case 'pie-chart':
                return _jsx(PieChart, { setup: setup, chartData: chartData }, index);
            case 'stack-area-chart':
            case 'stack-bar-chart':
                return _jsx(StackChart, { setup: setup, chartData: chartData }, index);
            case 'table':
                return _jsx(Table, { setup: setup, chartData: chartData }, index);
            default:
                return _jsxs("div", { children: ["Unknown chart type: ", JSON.stringify(setup)] }, index);
        }
    };
    var renderSubChartComponent = function () {
        if (status !== 'loaded' || !configuration.fnGetSubComponentChartItem || !subChartData) {
            return _jsx(_Fragment, {});
        }
        return configuration.fnGetSubComponentChartItem({ subData: subChartData, setup: setup });
    };
    var renderNoData = function () {
        if (status === 'loading') {
            if (configuration.loadingComponentChartItem)
                return configuration.loadingComponentChartItem;
            return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-loading", children: _jsx("h1", { children: "Loading chart item..." }) }));
        }
        if (status === 'empty') {
            if (configuration.emptyComponentChartItem)
                return configuration.emptyComponentChartItem;
            return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-empty", children: _jsx("h1", { children: "No data for chart item" }) }));
        }
        if (status === 'error') {
            if (configuration.errorComponentChartItem)
                return configuration.errorComponentChartItem;
            return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-error", children: _jsx("h1", { children: "Error chart item" }) }));
        }
    };
    return (_jsxs("div", { className: "s-dasboard__item", style: {
            gridColumn: "".concat(Number(setup.x) + 1, " / span ").concat(setup.width),
            gridRow: "".concat(Number(setup.y) + 1, " / span ").concat(setup.height),
        }, children: [_jsx(ChartTitle, { setup: setup }), renderNoData(), renderChartComponent(), renderSubChartComponent()] }, index));
};
export default ChartContainer;
